/***************************************************************************
                          kschoolmenu.h  -  description
                             -------------------
    begin                : Sun Aug 11 22:14:36 CEST 2002
    copyright            : (C) 2002 by Morten Hustveit
    email                : mortehu@ifi.uio.no
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef KSCHOOLMENU_H_
#define KSCHOOLMENU_H_

#include <qvector.h>
#include <qpixmap.h>
#include <qstring.h>

#include <kcmodule.h>
#include <kaboutdata.h>

class QLabel;
class QComboBox;
class QPushButton;
class QListView;
class KStandardDirs;

class MenuItem
{
public:
  MenuItem(const QPixmap& icon, const QString& name, const QString& path);
  ~MenuItem();

  void Hide () ; 
  void Show () ; 
  inline bool Hidden () { return hidden ; } ;

  const QPixmap     icon;
  const QString     name;
  const QString     path;
  QVector<MenuItem> children;

  QString desktopFile;

private:
  bool        hidden; 
};

class KSchoolmenu : public KCModule
{
Q_OBJECT

public:

  KSchoolmenu(QWidget* parent = 0L, const char* name = 0L);
  virtual ~KSchoolmenu();

  void load();
  void save();
  int buttons();
  QString quickHelp() const;
  const KAboutData* aboutData() { return myAboutData; };

public slots:

  void buttonAddClicked();
  void buttonRemoveClicked();
  void buttonRightClicked();
  void buttonLeftClicked();
  void listAvailableItemsSelectionChanged();
  void listCurrentMenuSelectionChanged();
  void comboCustomMenusActivated(int);

private:

  KAboutData* myAboutData;

  KStandardDirs* standardDirs;

  // The data

  MenuItem          availableItems;
  QVector<MenuItem> customMenus;

  // The widgets representing the data

  QListView*   listAvailableItems;
  QListView*   listCurrentMenu;
  QComboBox*   comboCustomMenus;
  QPushButton* buttonAdd;
  QPushButton* buttonRemove;  
  QPushButton* buttonRight;
  QPushButton* buttonLeft;
  QLabel*      labelCustomMenu;
  QLabel*      labelAvailableItems;
  QLabel*      labelCurrentMenu;
};

#endif
